@import Foundation;
#import <objc/runtime.h>

@interface SKManager:NSObject
@end

@interface Inject:NSObject
@end
@implementation Inject

+(void)load
{	
	[self log:@"loaded"];
	
	[self swapMethodsForClass:SKManager.class real:@selector(defaultVisibleRoles) fake:@selector(fakeDefaultVisibleRoles) instance:false];
}

+(void)log:(NSString*)message
{
	NSLog(@"ASentientBot volume role inject: %@",message);
}

+(void) swapMethodsForClass:(Class)class real:(SEL)realSelector fake:(SEL)fakeSelector instance:(BOOL)instance
{
	[self log:@"swizzling"];
	
	Method realMethod;
	Method fakeMethod;
	
	if(instance)
	{
		realMethod=class_getInstanceMethod(class,realSelector);
		fakeMethod=class_getInstanceMethod(class,fakeSelector);
	}
	else
	{
		realMethod=class_getClassMethod(class,realSelector);
		fakeMethod=class_getClassMethod(class,fakeSelector);
	}
	
	method_exchangeImplementations(realMethod,fakeMethod);
}
@end

NSSet* allRoles;

@interface SKManager(FakeSKManager)
@end
@implementation SKManager(FakeSKManager)
+(NSSet*)fakeDefaultVisibleRoles
{
	if(!allRoles)
	{
		[Inject log:@"have some extra roles 🙂"];
		
		// strings /System/Library/PrivateFrameworks/StorageKit.framework/StorageKit | grep kSKDiskRole
		allRoles=[NSSet setWithArray:@[@"kSKDiskRoleLegacyMacData",@"kSKDiskRoleLegacyMacSystem",@"kSKDiskRoleMacData",@"kSKDiskRoleMacSystem",@"kSKDiskRoleMacSystemData",@"kSKDiskRoleMacUserData",@"kSKDiskRoleMacApplicationData",@"kSKDiskRoleWindowsSystem",@"kSKDiskRoleWindowsData",@"kSKDiskRoleXSanData",@"kSKDiskRoleDigitalCameraData",@"kSKDiskRoleExternalMedia",@"kSKDiskRoleBooter",@"kSKDiskRoleVirtualMemory",@"kSKDiskRoleRecovery",@"kSKDiskRoleStorageImplementation",@"kSKDiskRolePhysicalDisk",@"kSKDiskRoleUnknown",@"kSKDiskRoleNoRole",@"kSKDiskRoleSnapshot"]];
		[allRoles retain];
	}
	
	return allRoles;
}
@end